
package dev.sonpx.loyalty.mcp.reward.enums;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import java.util.Arrays;
import lombok.Getter;
import lombok.RequiredArgsConstructor;

/**
 * Created by SonPhung on Friday, 10-Nov-2023
 */
@Getter
@RequiredArgsConstructor
public enum AwardFactorType {
    PERCENT("GA"),
    POOL_UNIT("NA");

    @JsonValue
    private final String code;

    @JsonCreator
    public static AwardFactorType fromCode(String code) {
        return Arrays.stream(values())
                .filter(e -> e.code.equalsIgnoreCase(code))
                .findFirst()
                .orElse(null);
    }
}
